Updated: 2012-06-05 Due date:
Remote issue URL:
Affected version:
Description: There should be a property "Main Branch" for Git Repositories. Master is not in any case the branch i want to 

show in the repository view. In many cases a branch like stable or current release make more sense. 

I have seen this Feature on bitbucket and like it.

Associated revisions
2012-06-05 03:33 pm - Justin Geibel
Change default branch behaviour for git repos #749

If git repository HEAD points to a branch, use that as the default branch.
Otherwise fall back to previous method.

History
2011-12-02 09:20 pm - Justin Geibel
If someone can point me in the right direction I might be able to put together a patch for this.

2011-12-02 10:59 pm - Toshi MARUYAMA
Bitbucket and github write HEAD file on bare repository.

<pre>
$ cat HEAD 
ref: refs/heads/master
$ git branch
  latin-1-path-encoding
* master
  test-latin-1
  test_branch
</pre>

2011-12-02 11:01 pm - Toshi MARUYAMA
<pre>
$ cat packed-refs 
# pack-refs with: peeled 
1ca7f5ed374f3cb31a93ae5215c2e25cc6ec5127 refs/heads/latin-1-path-encoding
83ca5fd546063a3c7dc2e568ba3355661a9e2b2c refs/heads/master
67e7792ce20ccae2e4bb73eed09bb397819c8834 refs/heads/test-latin-1
fba357b886984ee71185ad2065e65fc0417d9b92 refs/heads/test_branch
7234cb2750b63f47bff735edc50a1c0a433c2518 refs/tags/tag00.lightweight
1399e2fe59e43d76a15ab922419980d8fa8c9143 refs/tags/tag01.annotated
^899a15dba03a3b350b89c3f537e4bbe02a03cdc9

</pre>

2011-12-03 05:18 am - Justin Geibel
Okay, so I'm thinking about updating the default_branch function so that it calls scm_cmd to run `git symbolic-ref HEAD`.  If head points to a branch, 
this should return something like /refs/heads/master.  If head points to a specific SHA then git will return an error so we can fall back to the existing 
approach.

This has the benefit that I don't have to add a specific setting to the interface for this, but it does require that the user has write access to the HEAD file 
in order to change the default.

2011-12-03 10:57 pm - Justin Geibel
- Target version set to 2.6.0

- Status changed from Open to Ready for review

You can find my proposed change at https://github.com/chiliproject/chiliproject/pull/138/files

2011-12-17 10:40 pm - Eric Davis
- Target version deleted (2.6.0)

- Status changed from Ready for review to Open

Gave some feedback on the pull request about adding some tests.

Removing from 2.6.0 until the code is complete and merged.

2011-12-19 04:22 pm - Felix Schäfer
- Assignee set to Felix Schäfer

- Status changed from Open to Ready for review

Looks good so far, I'll probably be able to merge it for 2.6.0.

2012-02-12 10:31 am - Toshi MARUYAMA
I implemented in Redmine 1.4.
http://www.redmine.org/issues/10207

2012-06-05 03:39 pm - Felix Schäfer
- Status changed from Ready for review to Closed

- Target version set to 3.2.0

Merged in commit:1722e96, thanks!
